#ifndef __SCI_H__
#define __SCI_H__

/*
 * SCIRg[郋[`
 * 
 * @author fenrir (M.Naruoka)
 * @since 04/06/04
 * @version 1.0
 */

#ifdef __cplusplus
extern "C"
{
#endif

#include <util/fifo_char.h>

/* SCI3 */
#ifndef SCI3_DISABLE

#ifndef SCI3_TX_BUFFER_SIZE
  #define SCI3_TX_BUFFER_SIZE 31
#endif
#ifndef SCI3_RX_BUFFER_SIZE
  #define SCI3_RX_BUFFER_SIZE 15
#endif

  void sci3_init();
  fifo_char_size_t sci3_write(char *data, fifo_char_size_t size);
  fifo_char_size_t sci3_read(char *c, fifo_char_size_t size);
  fifo_char_size_t sci3_tx_size();
  fifo_char_size_t sci3_rx_size();

#endif /* SCI3_DISABLE */

#ifdef __cplusplus
};
#endif

#endif /* __SCI_H__ */
