/*
 * Ring BufferƂFIFO\wb_t@C
 * ring_buffer.cC\[X
 * 
 * @author fenrir (M.Naruoka)
 * @since 04/05/30
 * @version 1.0
 */

#ifndef __FIFO_CHAR_H__
#define __FIFO_CHAR_H__

#ifdef __cplusplus
extern "C"
{
#endif

#ifndef FIFO_CHAR_SIZE_T
	#define FIFO_CHAR_SIZE_T int
#endif

typedef FIFO_CHAR_SIZE_T fifo_char_size_t;

typedef struct rbuffer_char_t{
	char *buffer;
	fifo_char_size_t size;
	char *prius;
	char *follower;
} fifo_char_t;
/* Oobt@[
 * follower(ǂ)prius(s)ɒǂƂ͂łȂAǂƂłȂ
 * prius(s)follower(ǂ)ɒǂƂ͂ł邪AǂƂ͂łȂ
 */

fifo_char_t *fifo_char_init(fifo_char_t *buffer, char *c, fifo_char_size_t size);
fifo_char_size_t fifo_char_write(fifo_char_t *buffer, char *data, fifo_char_size_t size);
fifo_char_size_t fifo_char_read(fifo_char_t *buffer, char *c, fifo_char_size_t size);
fifo_char_size_t fifo_char_size(fifo_char_t *buffer);

#ifdef __cplusplus
}
#endif

#endif /* __FIFO_CHAR_H__ */
