/*
 * A/Dϊs[`
 * 
 * @author fenrir (M.Naruoka)
 * @since 04/06/02
 * @version 1.0
 */
#include "AKI3694.h"
#include <common.h>
#include <util/fifo_num.h>
#include "ad.h"

static num_t buffer_ad[(AD_BUFFER_SIZE + 1) * AD_CH];
fifo_num_t fifo_ad[AD_CH];

/**
 * A/Dϊ̏ݒ֐
 * 
 */
void ad_init(){
	
	/* A/DϊpFIFȌ */
	int i;
	for(i = 0; i < AD_CH; i++){
		fifo_num_init(&(fifo_ad[i]), &(buffer_ad[(AD_BUFFER_SIZE + 1) * i]), (AD_BUFFER_SIZE + 1));
	}
	
	/* A/Dϊ~ */
	AD.ADCSR.BIT.ADST = 0;
	
	/* XL[h
	 * ϊ
	 * 荞݉
	 * ͂߂̓O[v0AD0`AD3ϊ
	 * 8`l͂ɂ̌O[v1AD4`AD7ϊ
	 */
  AD.ADCSR.BYTE = 0x5b;  //5
}

/**
 * A/Dϊ̊Jn֐
 * C^[o^C}̊荞݂ɂāA
 * ܂O[v0ADϊIɌĂяoĂ炤B
 * 
 * @see ad_end();
 */
void ad_start(){
	AD.ADCSR.BIT.ADST = 1; /* A/DϊX^[g */
}

/**
 * A/Dϊ̏IɋN֐
 * 荞݂ŌĂяoĂ炤
 * 
 * @see int_ad();
 */
void ad_end(){

	AD.ADCSR.BYTE &= 0x5f;  /* ItONA & ADϊS~*/

#if AD_CH > 4
	/* ǂ̃O[vϊĂ */
	if((AD.ADCSR.BYTE & 0x04) == 0){
#endif

		/* O[v0(AD0`AD3)ϊĂ */
		
#if DEBUG > 2
		fifo_num_write(&fifo_ad[0], 230);
		fifo_num_write(&fifo_ad[1], 340);
		fifo_num_write(&fifo_ad[2], 560);
		fifo_num_write(&fifo_ad[3], 780);
#else
		/*fifo_num_write(&fifo_ad[0], ((AD.ADDRA_H << 8) | AD.ADDRA_L));  */
    fifo_num_write(&fifo_ad[0], AD.ADDRA.u16);
		fifo_num_write(&fifo_ad[1], AD.ADDRB.u16);
		fifo_num_write(&fifo_ad[2], AD.ADDRC.u16);
		fifo_num_write(&fifo_ad[3], AD.ADDRD.u16);
#endif

#if AD_CH > 4
		AD.ADCSR.BYTE |= 0x04; /* O[v1ɐ؂ւ */
		ad_start(); /* ēxADϊ */
	}else{
		
		/* O[v1(AD4`AD7)ϊĂ */

#if DEBUG > 2
		fifo_num_write(&fifo_ad[4], 230);
		fifo_num_write(&fifo_ad[5], 340);
		fifo_num_write(&fifo_ad[6], 560);
		fifo_num_write(&fifo_ad[7], 780);
#else
		fifo_num_write(&fifo_ad[4], AD.ADDRA.u16);
		fifo_num_write(&fifo_ad[5], AD.ADDRB.u16);
		fifo_num_write(&fifo_ad[6], AD.ADDRC.u16);
		fifo_num_write(&fifo_ad[7], AD.ADDRD.u16);
#endif
		
		AD.ADCSR.BYTE &= ~(0x04); /* O[v0ɐ؂ւ */
	}
#endif
}

/**
 * A/Dϊ̏IɂČĂт銄荞݊֐
 * 
 * @see ad_end
 */
#pragma interrupt
void int_ad(){
	if(AD.ADCSR.BIT.ADF){AD.ADCSR.BIT.ADF = 0;}
	ad_end();
}
