/*
 * Oobt@(FIFO)\C\[X
 * ͕(char)pB
 * 
 * @author fenrir (M.Naruoka)
 * @since 04/05/30
 * @version 1.0
 */

#include <stdio.h>
#include <common.h>
#include "fifo_char.h"

/**
 * Oobt@܂B
 * 
 * @param buffer 郊Oobt@
 * @param c ۂɃobt@Ƃċ@\̈
 * @param size ۂ̃obt@TCYAc̑傫
 * @return (fifo_char_t) ꂽOobt@
 */
fifo_char_t *fifo_char_init(fifo_char_t *buffer, char *c, fifo_char_size_t size){
	
	if(size > 0){
		
		buffer->buffer = c;
		buffer->size = size;
		buffer->prius = buffer->buffer;	
		buffer->follower = buffer->buffer + size - 1;
		return buffer;
	}else{return NULL;}
}

/**
 * Oobt@Ƀf[^݂܂B
 * 
 * @param buffer ޑΏۃOobt@
 * @param data ރf[^
 * @param size ރf[^̃TCY(byte)
 * @return int ɏ܂ꂽf[^̃TCY(byte)
 */
fifo_char_size_t fifo_char_write(fifo_char_t *buffer, char *data, fifo_char_size_t size){
	
	fifo_char_size_t _size = 0;
	
	if(data != NULL){
	
		/* obt@ɏ */
		while(_size < size){
			
			if(buffer->prius == buffer->buffer + buffer->size){buffer->prius = buffer->buffer;}
			if(buffer->prius == buffer->follower){break;}
			*((buffer->prius)++) = *(data + (_size++));
		}
	}
	
	return _size;
}

/**
 * Oobt@f[^ǂݎ܂B
 * 
 * @param buffer ǂݍ݌ƂȂ郊Oobt@
 * @param c ǂݎf[^i[obt@
 * @param size őǂݍ݃TCY(byte)
 * @return int ǂݎf[^̑傫(byte)
 */
fifo_char_size_t fifo_char_read(fifo_char_t *buffer, char *c, fifo_char_size_t size){
	
	fifo_char_size_t _size = 0;
	
	if(c != NULL){
	
		/* Ǎɏ */
		while(_size < size){
		
			if((buffer->follower + 1 - buffer->prius) % buffer->size == 0){break;}
			if(++buffer->follower == buffer->buffer + buffer->size){buffer->follower = buffer->buffer;}
			*(c + (_size++)) = *(buffer->follower);
		}
	}
	
	return _size;
}

/**
 * Oobt@ɂf[^TCY߂܂B
 * 
 * @param buffer Oobt@
 * @return int obt@̃f[^̑傫(byte)
 */
fifo_char_size_t fifo_char_size(fifo_char_t *buffer){
	
	return (buffer->prius > buffer->follower ?
		       buffer->prius - buffer->follower - 1:
		       buffer->prius + buffer->size - buffer->follower - 1);
}
