/*
 * Oobt@(FIFO)\C\[X
 * ͐lpB
 * num_t`Ďgp̂
 * 
 * @author fenrir (M.Naruoka)
 * @since 04/05/30
 * @version 1.0
 */

#include <stdio.h>
#include <common.h>
#include "fifo_num.h"

/**
 * FIFO܂B
 * 
 * @param buffer FIFO
 * @param array ۂɃobt@Ƃċ@\̈
 * @param size ۂ̃obt@TCYAarray̑傫
 * @return (fifo_num_t) ꂽOobt@
 */
fifo_num_t *fifo_num_init(fifo_num_t *buffer, num_t *array, fifo_num_size_t size){
	
	if(size > 0){
		
		buffer->buffer = array;
		buffer->size = size;
		buffer->prius = buffer->buffer;	
		buffer->follower = buffer->buffer + size - 1;
		return buffer;
	}else{return NULL;}
}

/**
 * FIFOɐlf[^݂܂B
 * 
 * @param buffer ޑΏFIFO
 * @param data ސlf[^
 * @return (accuracy *) ɏ܂ꂽǂANULLُ͈
 */
num_t *fifo_num_write(fifo_num_t *buffer, num_t data){
	
	/* 󂢂Ă邩`FbN */
	if(buffer->prius != buffer->follower){
		if(buffer->prius == buffer->buffer + buffer->size){buffer->prius = buffer->buffer;}
		*(buffer->prius++) = data;
		return buffer->prius;
	}
	
	return NULL;
}

/**
 * FIFO琔lf[^ǂݎ܂B
 * 
 * @param buffer ǂݍ݌ƂȂFIFO
 * @param data ǂݎf[^i[obt@
 * @return (accuracy *) ǂݎf[^i[obt@Af[^ǂݍ܂ȂꍇANULL
 */
num_t *fifo_num_read(fifo_num_t *buffer, num_t *data){
	
	if(data != NULL){
	
		/* Oobt@Ƀf[^邩`FbN */
		if(((buffer->follower + 1) - buffer->prius) % buffer->size != 0){
			
			/* Ǎɏ */
			if(++buffer->follower == buffer->buffer + buffer->size){buffer->follower = buffer->buffer;}
			*data = *(buffer->follower);
			return data;
		}
	}
	
	return NULL;
}

/**
 * FIFOɂf[^̌擾܂B
 * 
 * @param buffer FIFO
 * @return (int) FIFOɂf[^̌
 */
fifo_num_size_t fifo_num_size(fifo_num_t *buffer){
	
	return (buffer->prius > buffer->follower ?
		       buffer->prius - buffer->follower - 1:
		       buffer->prius + buffer->size - buffer->follower - 1);
}
