/*
 * lpRing Buffer(FIFO)̃wb_t@C
 * fifo_num.cC\[X
 * 
 * @author fenrir (M.Naruoka)
 * @since 04/05/30
 * @version 1.0
 * @see fifo_num.c
 * @see common.h
 */

#ifndef __FIFO_NUM_H__
#define __FIFO_NUM_H__

#ifdef __cplusplus
extern "C"
{
#endif

#ifndef FIFO_NUM_SIZE_T
#define FIFO_NUM_SIZE_T int
#endif

typedef FIFO_NUM_SIZE_T fifo_num_size_t;

#ifndef FIFO_NUM_T
#define FIFO_NUM_T int
#endif

typedef FIFO_NUM_T num_t;


typedef struct{
	num_t *buffer;
	fifo_num_size_t size;
	num_t *prius;
	num_t *follower;
} fifo_num_t;
/* Oobt@[
 * follower(ǂ)prius(s)ɒǂƂ͂łȂAǂƂłȂ
 * prius(s)follower(ǂ)ɒǂƂ͂ł邪AǂƂ͂łȂ
 */

fifo_num_t *fifo_num_init(fifo_num_t *buffer, num_t *array, fifo_num_size_t size);
num_t *fifo_num_write(fifo_num_t *buffer, num_t data);
num_t *fifo_num_read(fifo_num_t *buffer, num_t *data);
fifo_num_size_t fifo_num_size(fifo_num_t *buffer);

#ifdef __cplusplus
};
#endif

#endif /* __FIFO_NUM_H__ */
